#!/usr/bin/env python3
import rospy

from .{{ skill }}_abstract_manager import Abstract{{ skill.name|action_name }}Manager
{% if resources %}from {{ pkgname }}.srv import Transition{% endif %}

class Abstract{{ skill.name|action_name }}MockManager(Abstract{{ skill.name|action_name }}Manager):

    def __init__(self):
        super().__init__()
        self.__progress = 0.0

        self.__terminals = dict()
        {% for result in skill.results %}
        self.__terminals['{{ result.name }}'] = self.terminated_{{ result.name }}
        {% endfor %}

        # sleep time for the validation step
        if not rospy.has_param("~validate_delay"):
            rospy.set_param("~validate_delay", 1.0)
        # sleep time for the dispatching step; <0 do not terminate
        if not rospy.has_param("~dispatch_delay"):
            rospy.set_param("~dispatch_delay", 1.0)
        # sleep time for the interruption step; <0 do not terminate
        if not rospy.has_param("~interrupt_delay"):
            rospy.set_param("~interrupt_delay", 1.0)
        # result of the validation step
        if not rospy.has_param("~validate_result"):
            rospy.set_param("~validate_result", True)
        # termination result after dispatching
        if not rospy.has_param("~dispatch_result"):
            rospy.set_param("~dispatch_result", "{{ skill.results | first }}")
        # termination result after interruption
        if not rospy.has_param("~interrupt_result"):
            rospy.set_param("~interrupt_result", "{{ skill.results | first }}")
        # side-effects on resources when dispatch is terminating, as a dict 'resource'->'state'
        if not rospy.has_param("~dispatch_sideeffects"):
            rospy.set_param("~dispatch_sideeffects", {})
        # side-effects on resources when interrupt is terminating, as a dict 'resource'->'state'
        if not rospy.has_param("~interrupt_sideeffects"):
            rospy.set_param("~interrupt_sideeffects", {})

    def sleep(self, delay):
        if delay > 0:
            rospy.sleep(delay)

    def validate(self, goal):
        rospy.loginfo(f"[{{skill}}_manager] validate goal {goal}")
        delay = rospy.get_param("~validate_delay")
        rospy.logdebug(f"[{{skill}}_manager] validation delay: {delay}")
        self.sleep(delay)
        self.__progress = 0.0
        result = rospy.get_param("~validate_result")
        rospy.logdebug(f"[{{skill}}_manager] validation result: {result}")
        return result

    def on_dispatch(self, goal_id, goal):
        rospy.loginfo(f"[{{skill}}_manager] on_dispatch {goal}")
        self.__delay = rospy.get_param("~dispatch_delay")
        rospy.logdebug(f"[{{skill}}_manager] dispatching delay: {self.__delay}")
        if self.__delay > 0:
            self.sleep(self.__delay)
        if self.__delay < 0:
            return
        rospy.loginfo(f"[{{skill}}_manager] terminating {goal}")
        sideeffects = rospy.get_param("~dispatch_sideeffects")
        for resource, state in sideeffects.items():
            rospy.logwarn(f"[{{skill}}_manager] applying effect on resource {resource} -> {state}")
            client = rospy.ServiceProxy(f"resource/change_{resource}", Transition)
            client(target=state)
        result = rospy.get_param("~dispatch_result")
        rospy.logdebug(f"[{{skill}}_manager] dispatching terminal result {result}")
        self.__terminals[result](goal_id)

    def on_interrupt(self, goal_id, goal):
        rospy.loginfo(f"[{{skill}}_manager] on_interrupt {goal}")
        delay = rospy.get_param("~interrupt_delay")
        rospy.logdebug(f"[{{skill}}_manager] interruption delay: {delay}")
        if delay > 0:
            self.sleep(delay)
        if delay < 0:
            return
        rospy.loginfo(f"[{{skill}}_manager] terminating {goal}")
        sideeffects = rospy.get_param("~interrupt_sideeffects")
        for resource, state in sideeffects.items():
            rospy.logwarn(f"[{{skill}}_manager] applying effect on resource {resource} -> {state}")
            client = rospy.ServiceProxy(f"resource/change_{resource}", Transition)
            client(target=state)
        result = rospy.get_param("~interrupt_result")
        rospy.logdebug(f"[{{skill}}_manager] interruption terminal result {result}")
        self.__terminals[result](goal_id)

    def progress(self, goal_id, goal):
        rospy.loginfo(f"[{{skill}}_manager] progress {goal}: {self.__progress}")
        if self.__progress < self.__delay:
            self.__progress += self.progress_period / self.__delay
        return self.__progress
    
    {% for effect in skill.effects %}
    def on_effect_{{ effect.name }}(self):
        rospy.loginfo("[{{skill}}_manager] on_effect {{ effect.name }}")
    {% endfor %}
